import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedHashMap;


public class SCTCDFTiming {

	public static void main(String[] args) throws NumberFormatException, IOException {
		LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
		map.put("SerialNumber", 0);
		map.put("Version", 1);
		map.put("Type", 2);
		map.put("SigAlgName", 3);
		map.put("SigAlgOID", 4);
		map.put("IssuerName", 5);
		map.put("KeyUsage", 6);
		map.put("SignatureLength", 7);
		map.put("PublicKeyLength", 8);
		map.put("NotBefore", 9);
		map.put("NotAfter", 10);
		map.put("SubjectName",11);
		map.put("SubjectUniqueID", 12);
		map.put("HandshakeTime", 13);
		map.put("SCTOCSPTime", 14);
		map.put("SCTTLSExtensionTime", 15);
		map.put("SCTX509ExtensionTime", 16);
		map.put("UsedSCTOCSP", 17);
		map.put("UsedSCTTLSExtension", 18);
		map.put("UsedSCTX509Extension", 19);
		map.put("BytesReceived", 20);
		map.put("BytesSent", 21);
		map.put("SCTOCSPLength", 22);
		map.put("SCTTLSExtensionLength", 23);
		map.put("SCTX509ExtensionLength", 24);
		map.put("PublicKeyAlgo", 25);
		map.put("ValidationTime", 26);
		map.put("Valid", 27);
		map.put("Site", 28);
		map.put("Position", 29);
		// TODO Auto-generated method stub
		FileInputStream fis = new FileInputStream(args[0]);
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		
		String delimiter = ";;;";
		String strLine;
		int ocspTime = 0;
		int tlsTime = 0;
		int x509Time = 0;
		int siteCount = 0;
		
		// Highest value of ocsp, tls, x509
		int oH = 0;
		int tH = 0;
		int xH = 0;
		
		int countOCSP = 0;
		int countTLS = 0;
		int countX509 = 0;
		
		//Read File Line By Line
		while ((strLine = br.readLine()) != null) 
		{
			String[] values = strLine.split(delimiter);
			if(values.length == 31 && (values[17].equals("true") || values[18].equals("true") || values[19].equals("true")))
			{
				if(values[17].equals("true"))
					countOCSP++;
				if(values[18].equals("true"))
					countTLS++;
				if(values[19].equals("true"))
					countX509++;
				
				int o = Integer.parseInt(values[14]);
				int t = Integer.parseInt(values[15]);
				int x = Integer.parseInt(values[16]);
				ocspTime += o;
				tlsTime += t;
				x509Time += x;
				
				if(o > oH)
					oH = o;
				if(t > tH)
					tH = t;
				if(x > xH)
					xH = x;
				siteCount++;
			}
		}
		int val = 0;
		if(countOCSP != 0)
			val = ocspTime/countOCSP;
		System.out.println("OCSP: " + val);
		System.out.println("OCSP Highest: " + oH);
		System.out.println("TLS: " + tlsTime/countTLS);
		System.out.println("TLS Highest: " + tH);
		System.out.println("X509: " + x509Time/countX509);
		System.out.println("X509 Highest: " + xH);
		System.out.println("Sites that used SCT: " + siteCount);
		
	}

}
