import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Map.Entry;
import java.util.regex.Pattern;

public class SCTLogCounter {

	public static void main(String[] args) throws IOException {
		LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
		map.put("SerialNumber", 0);
		map.put("Version", 1);
		map.put("Type", 2);
		map.put("SigAlgName", 3);
		map.put("SigAlgOID", 4);
		map.put("IssuerName", 5);
		map.put("KeyUsage", 6);
		map.put("SignatureLength", 7);
		map.put("PublicKeyLength", 8);
		map.put("NotBefore", 9);
		map.put("NotAfter", 10);
		map.put("SubjectName",11);
		map.put("SubjectUniqueID", 12);
		map.put("HandshakeTime", 13);
		map.put("SCTOCSPTime", 14);
		map.put("SCTTLSExtensionTime", 15);
		map.put("SCTX509ExtensionTime", 16);
		map.put("UsedSCTOCSP", 17);
		map.put("UsedSCTTLSExtension", 18);
		map.put("UsedSCTX509Extension", 19);
		map.put("BytesReceived", 20);
		map.put("BytesSent", 21);
		map.put("SCTOCSPLength", 22);
		map.put("SCTTLSExtensionLength", 23);
		map.put("SCTX509ExtensionLength", 24);
		map.put("PublicKeyAlgo", 25);
		map.put("ValidationTime", 26);
		map.put("Valid", 27);
		map.put("Site", 28);
		map.put("Position", 29);
		map.put("IPAddress", 30);
		map.put("Date", 31);
		map.put("SCTDecodeTime", 32);
		map.put("SCTBundleLength", 33);
		map.put("AmountSCTs", 34);
		map.put("SCTs", 35);
		
		try{
			SCTExtension scte = new SCTExtension(new byte[]{});
		}catch(Exception e){}
		
		LinkedList<Integer> lmOCSP = new LinkedList<>();
		LinkedList<Integer> lmTLS = new LinkedList<>();
		LinkedList<Integer> lmX509 = new LinkedList<>();
		// TODO Auto-generated method stub
		FileInputStream fis = new FileInputStream("newData.txt");
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		
		LinkedHashMap<String, Integer> loggs = new LinkedHashMap<>();
		
		String delimiter = ";;;";
		String strLine;
		int count = 0;
		//Read File Line By Line
		while ((strLine = br.readLine()) != null) 
		{
			String[] values = strLine.split(delimiter, 37);
			if(values.length == 37 && (values[17].equals("true") || values[18].equals("true") || values[19].equals("true")))
			{
				String[] sctsText = values[36].split(Pattern.quote("|||"));
				for(String sctText : sctsText)
				{
					if(sctText != null && !sctText.equals(""))
					{
						String[] sctArr = sctText.split(delimiter);
						String name = sctArr[0];
						if(name.equals("null"))
						{
							if(SCTExtension.getLoggs().containsKey(sctArr[1]))
								name = SCTExtension.getLoggs().get(sctArr[1]);
							else
								name = sctArr[1];
						}
						
						if(loggs.containsKey(name))
						{
							int val = loggs.get(name).intValue() + 1;
							loggs.remove(name);
							loggs.put(name, val);
							count++;
						}
						else
						{
							loggs.put(name, 1);
							count++;
						}
					}
				}
			}
		}


		for(Entry<String, Integer> e : loggs.entrySet())
		{
			System.out.println(e.getKey() + " : " + ((double)e.getValue()/count)*100);
		}
			
	}
	
	private static void printToFile(LinkedList<Integer> ll, String file) throws IOException
	{
		File f = new File(file);
		f.createNewFile();
		PrintWriter pw = new PrintWriter(file);
		for(int i : ll)
		{
			pw.println(i);
		}
		pw.close();
	}

}
