import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedHashMap;

public class SCTMetodCounter {

	public static void main(String[] args) throws IOException {
		LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
		map.put("SerialNumber", 0);
		map.put("Version", 1);
		map.put("Type", 2);
		map.put("SigAlgName", 3);
		map.put("SigAlgOID", 4);
		map.put("IssuerName", 5);
		map.put("KeyUsage", 6);
		map.put("SignatureLength", 7);
		map.put("PublicKeyLength", 8);
		map.put("NotBefore", 9);
		map.put("NotAfter", 10);
		map.put("SubjectName",11);
		map.put("SubjectUniqueID", 12);
		map.put("HandshakeTime", 13);
		map.put("SCTOCSPTime", 14);
		map.put("SCTTLSExtensionTime", 15);
		map.put("SCTX509ExtensionTime", 16);
		map.put("UsedSCTOCSP", 17);
		map.put("UsedSCTTLSExtension", 18);
		map.put("UsedSCTX509Extension", 19);
		map.put("BytesReceived", 20);
		map.put("BytesSent", 21);
		map.put("SCTOCSPLength", 22);
		map.put("SCTTLSExtensionLength", 23);
		map.put("SCTX509ExtensionLength", 24);
		map.put("PublicKeyAlgo", 25);
		map.put("ValidationTime", 26);
		map.put("Valid", 27);
		map.put("Site", 28);
		map.put("Position", 29);
		// TODO Auto-generated method stub
		FileInputStream fis = new FileInputStream("newData.txt");
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		
		String delimiter = ";;;";
		String strLine;
		int countOCSP = 0;
		int countTLS = 0;
		int countX509 = 0;
		int countXT = 0;
		int countXO = 0;
		int countTO = 0;
		int countXTO = 0;
		
		int countNoHTTPS = 0;
		int countNoRespone = 0;
		int countUnknownHost = 0;
		int countTlsError = 0;
		int countUnknownError = 0;
		int countNoCT = 0;
		int siteCount = 0;
		//Read File Line By Line
		while ((strLine = br.readLine()) != null) 
		{
			int count = 0;
			String[] values = strLine.split(delimiter);
			if(values.length > 34)
			{
				if(values[17].equals("true") && values[18].equals("true") && values[19].equals("true"))
				{
					countXTO++;
					System.out.println(values[29] + " XTO");
				}
				else if(values[17].equals("true") && values[18].equals("true"))
				{
					countTO++;
					System.out.println(values[29] + " TO");
				}
				else if(values[17].equals("true") && values[19].equals("true"))
				{
					countXO++;
					System.out.println(values[29] + " XO");
				}
				else if(values[18].equals("true") && values[19].equals("true"))
				{
					countXT++;
					System.out.println(values[29] + " XT");
				}
				else if(values[17].equals("true"))
					countOCSP++;
				else if(values[18].equals("true"))
					countTLS++;
				else if(values[19].equals("true"))
					countX509++;
			}
			else if(values.length == 34)
			{
				countNoCT++;
			}
			else
			{
				if(strLine.contains("could not connect to this site, timed out"))
					countNoRespone++;
				else if(strLine.contains("does not have any x509 certificate or we could not find it"))
					countNoHTTPS++;
				else if(strLine.contains("!FAIL 4!"))
					countUnknownHost++;
				else if(strLine.contains("!FAIL 5!"))
					countTlsError++;
				else if(strLine.contains("!FAIL 6!") || strLine.contains("!FAIL 7!"))
					countUnknownError++;
			}
			siteCount++;
		}
		System.out.println("OCSP: " + countOCSP);
		System.out.println("TLS: " + countTLS);
		System.out.println("X509: " + countX509);
		System.out.println("No HTTPS: " + countNoHTTPS);
		System.out.println("No repsone: " + countNoRespone);
		System.out.println("Unknown host: " + countUnknownHost);
		System.out.println("Tls error: " + countTlsError);
		System.out.println("Unknown error: " + countUnknownError);
		System.out.println("Did not use CT: " + countNoCT);
		System.out.println("Amount of sites: " + siteCount);
	}

}
