import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Locale;
import java.util.Map.Entry;
import java.util.TimeZone;
import java.util.concurrent.TimeUnit;
import java.util.regex.Pattern;

public class SCTTimestampDiff {

	public static void main(String[] args) throws IOException, ParseException {
		// TODO Auto-generated method stub
		LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
		map.put("SerialNumber", 0);
		map.put("Version", 1);
		map.put("Type", 2);
		map.put("SigAlgName", 3);
		map.put("SigAlgOID", 4);
		map.put("IssuerName", 5);
		map.put("KeyUsage", 6);
		map.put("SignatureLength", 7);
		map.put("PublicKeyLength", 8);
		map.put("NotBefore", 9);
		map.put("NotAfter", 10);
		map.put("SubjectName",11);
		map.put("SubjectUniqueID", 12);
		map.put("HandshakeTime", 13);
		map.put("SCTOCSPTime", 14);
		map.put("SCTTLSExtensionTime", 15);
		map.put("SCTX509ExtensionTime", 16);
		map.put("UsedSCTOCSP", 17);
		map.put("UsedSCTTLSExtension", 18);
		map.put("UsedSCTX509Extension", 19);
		map.put("BytesReceived", 20);
		map.put("BytesSent", 21);
		map.put("SCTOCSPLength", 22);
		map.put("SCTTLSExtensionLength", 23);
		map.put("SCTX509ExtensionLength", 24);
		map.put("PublicKeyAlgo", 25);
		map.put("ValidationTime", 26);
		map.put("Valid", 27);
		map.put("Site", 28);
		map.put("Position", 29);
		map.put("IPAddress", 30);
		map.put("Date", 31);
		map.put("SCTDecodeTime", 32);
		map.put("SCTBundleLength", 33);
		map.put("AmountSCTs", 34);
		map.put("SCTs", 35);
		
		try{
			SCTExtension scte = new SCTExtension(new byte[]{});
		}catch(Exception e){}
		
		LinkedList<Integer> lmOCSP = new LinkedList<>();
		LinkedList<Integer> lmTLS = new LinkedList<>();
		LinkedList<Integer> lmX509 = new LinkedList<>();
		// TODO Auto-generated method stub
		FileInputStream fis = new FileInputStream("newData.txt");
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		
		LinkedList<Integer> time = new LinkedList<>();
		
		String delimiter = ";;;";
		String strLine;
		
		//Read File Line By Line
		while ((strLine = br.readLine()) != null) 
		{
			String[] values = strLine.split(delimiter, 39);
			if(values.length == 39 && (values[17].equals("true") || values[18].equals("true") || values[19].equals("true")))
			{
				String[] sctsText = values[38].split(Pattern.quote("|||"));
				for(String sctText : sctsText)
				{
					if(sctText != null && !sctText.equals(""))
					{
						try{
							String[] sctArr = sctText.split(delimiter);
							String date = sctArr[2];
							DateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.US);
							Date d = format.parse(date);
							
							Calendar c = Calendar.getInstance(TimeZone.getTimeZone("UTC"));
							Date today = c.getTime();
							
							long diff = today.getTime() - d.getTime();
							
							time.add((int)TimeUnit.DAYS.convert(diff, TimeUnit.MILLISECONDS));
						}
						catch(Exception e){e.printStackTrace();}
					}
				}
			}
		}
		
		Comparator<Integer> c = new Comparator<Integer>() {
			@Override
			public int compare(Integer o1, Integer o2) {
				// TODO Auto-generated method stub
				return o1.compareTo(o2);
			}
		};

		time.sort(c);
		printToFile(time, "CDF/DaysSinceSubmitted.txt");
		System.out.println("done!");
	}
	
	private static void printToFile(LinkedList<Integer> ll, String file) throws IOException
	{
		File f = new File(file);
		f.createNewFile();
		PrintWriter pw = new PrintWriter(file);
		for(long i : ll)
		{
			pw.println(i);
		}
		pw.close();
	}

}
