import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.LinkedHashMap;
import java.util.LinkedList;

public class ZeroSCTTime {

	public static void main(String[] args) throws IOException {
		LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
		map.put("SerialNumber", 0);
		map.put("Version", 1);
		map.put("Type", 2);
		map.put("SigAlgName", 3);
		map.put("SigAlgOID", 4);
		map.put("IssuerName", 5);
		map.put("KeyUsage", 6);
		map.put("SignatureLength", 7);
		map.put("PublicKeyLength", 8);
		map.put("NotBefore", 9);
		map.put("NotAfter", 10);
		map.put("SubjectName",11);
		map.put("SubjectUniqueID", 12);
		map.put("HandshakeTime", 13);
		map.put("SCTOCSPTime", 14);
		map.put("SCTTLSExtensionTime", 15);
		map.put("SCTX509ExtensionTime", 16);
		map.put("UsedSCTOCSP", 17);
		map.put("UsedSCTTLSExtension", 18);
		map.put("UsedSCTX509Extension", 19);
		map.put("BytesReceived", 20);
		map.put("BytesSent", 21);
		map.put("SCTOCSPLength", 22);
		map.put("SCTTLSExtensionLength", 23);
		map.put("SCTX509ExtensionLength", 24);
		map.put("PublicKeyAlgo", 25);
		map.put("ValidationTime", 26);
		map.put("Valid", 27);
		map.put("Site", 28);
		map.put("Position", 29);
		
		LinkedList<String> lmOCSP = new LinkedList<>();
		LinkedList<String> lmTLS = new LinkedList<>();
		LinkedList<String> lmX509 = new LinkedList<>();
		// TODO Auto-generated method stub
		FileInputStream fis = new FileInputStream("newData copy.txt");
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		
		
		
		String delimiter = ";;;";
		String strLine;
		int ocspTime = 0;
		int tlsTime = 0;
		int x509Time = 0;
		int siteCount = 0;
		
		// Highest value of ocsp, tls, x509
		int oH = 0;
		int tH = 0;
		int xH = 0;
		
		int countOCSP = 0;
		int countTLS = 0;
		int countX509 = 0;
		
		//Read File Line By Line
		while ((strLine = br.readLine()) != null) 
		{
			String[] values = strLine.split(delimiter);
			if(values.length > 31 && (values[17].equals("true") || values[18].equals("true") || values[19].equals("true")))
			{
				int o = Integer.parseInt(values[14]);
				int t = Integer.parseInt(values[15]);
				int x = Integer.parseInt(values[16]);
				
				if(values[17].equals("true") && o == 0)
					lmOCSP.add(values[29]);
				if(values[18].equals("true") && t == 0)
					lmTLS.add(values[29]);
				if(values[19].equals("true") && x == 0)
					lmX509.add(values[29]);
			}
		}
		
		printToFile(lmOCSP, lmTLS, lmX509, "CDF/ZeroDeliveryTime.txt");
		System.out.println("Done!");
		
	}
	
	private static void printToFile(LinkedList<String> l1, LinkedList<String> l2, LinkedList<String> l3, String file) throws IOException
	{
		File f = new File(file);
		f.createNewFile();
		PrintWriter pw = new PrintWriter(file);
		for(String s : l1)
		{
			pw.println("0,"+s);
		}
		for(String s : l2)
		{
			pw.println("0,"+s);
		}
		for(String s : l3)
		{
			pw.println("0,"+s);
		}
		pw.close();
	}

}
