import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;

public class dataFetcher {

	/**
	 * 
	 * @param args, arg0 = the file to read from, arg1 the file to write to, arg2 the parameters we want to fetch
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public static void main(String[] args) throws FileNotFoundException, IOException {
		// TODO Auto-generated method stub
		LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
		map.put("SerialNumber", 0);
		map.put("Version", 1);
		map.put("Type", 2);
		map.put("SigAlgName", 3);
		map.put("SigAlgOID", 4);
		map.put("IssuerName", 5);
		map.put("KeyUsage", 6);
		map.put("SignatureLength", 7);
		map.put("PublicKeyLength", 8);
		map.put("NotBefore", 9);
		map.put("NotAfter", 10);
		map.put("SubjectName",11);
		map.put("SubjectUniqueID", 12);
		map.put("HandshakeTime", 13);
		map.put("SCTOCSPTime", 14);
		map.put("SCTTLSExtensionTime", 15);
		map.put("SCTX509ExtensionTime", 16);
		map.put("UsedSCTOCSP", 17);
		map.put("UsedSCTTLSExtension", 18);
		map.put("UsedSCTX509Extension", 19);
		map.put("BytesReceived", 20);
		map.put("BytesSent", 21);
		map.put("SCTOCSPLength", 22);
		map.put("SCTTLSExtensionLength", 23);
		map.put("SCTX509ExtensionLength", 24);
		map.put("PublicKeyBase64", 25);
		map.put("PublicKeyAlgo", 26);
		map.put("ValidationTime", 27);
		map.put("Valid", 28);
		map.put("Site", 29);
		map.put("Position", 30);
		
		String delimiter = ";;;";
		
		FileInputStream fis = new FileInputStream(args[0]);
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		PrintWriter pw = new PrintWriter(args[1]);
		String[] keys = args[2].split(",");
		LinkedHashMap<String, Integer> usingMap = new LinkedHashMap<>();
		for(String key : keys)
		{
			int value = map.get(key);
			usingMap.put(key, value);
		}
		String strLine;
		int count = 1;
		//Read File Line By Line
		while ((strLine = br.readLine()) != null)   {
			StringBuilder sb = new StringBuilder();
			// Print the content on the console
			String[] values = strLine.split(delimiter);
			if(values.length == 31)
			{
				for(Entry<String, Integer> entry : usingMap.entrySet())
				{	
					sb.append(values[entry.getValue()] + delimiter);  
				}
				sb.setLength(sb.length()-3);
				pw.println(sb.toString());
			}
			else
				pw.println(values[0]);
			System.out.println(count);
			count++;
		}
		System.out.println("done!");
		
		pw.close();
		//Close the input stream
		br.close();
		
	}

}
